from niveristand._decorators import task
from niveristand.library._tasks import multitask, nivs_yield, stop_task
from niveristand.library.primitives import (
    abstime,
    arraysize,
    clearfault,
    clearlasterror,
    deltat,
    deltatus,
    fault,
    fix,
    generate_error,
    getlasterror,
    iteration,
    localhost_wait,
    quotient,
    rand,
    recip,
    rem,
    seqtime,
    seqtimeus,
    tickcountms,
    tickcountus,
)
from niveristand.library.timing import (
    wait,
    wait_until_next_ms_multiple,
    wait_until_next_us_multiple,
    wait_until_settled,
)
from niveristand.library.waveforms import (
    ramp,
    sawtooth_wave,
    sine_wave,
    square_wave,
    triangle_wave,
    uniform_white_noise_wave,
)

__all__ = [
    "abstime",
    "arraysize",
    "clearfault",
    "clearlasterror",
    "deltat",
    "deltatus",
    "fault",
    "fix",
    "generate_error",
    "getlasterror",
    "iteration",
    "localhost_wait",
    "multitask",
    "nivs_yield",
    "quotient",
    "recip",
    "rand",
    "rem",
    "ramp",
    "sawtooth_wave",
    "sine_wave",
    "square_wave",
    "triangle_wave",
    "uniform_white_noise_wave",
    "seqtime",
    "seqtimeus",
    "stop_task",
    "task",
    "tickcountms",
    "tickcountus",
    "wait",
    "wait_until_next_ms_multiple",
    "wait_until_next_us_multiple",
    "wait_until_settled",
]
